Unit QS20R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTF1C_p, UTQS10_p;

procedure QS20R(var U :Array of Real; var V :Array of Real; A :Real;
                B :Real; F :Proc_F3; N :Integer; var IERR :Integer);

implementation

procedure QS20R(var U :Array of Real; var V :Array of Real; A :Real;
                B :Real; F :Proc_F3; N :Integer; var IERR :Integer);
var
IN_,K,KK :Integer;
D,D1,F1,F2,P,X :Real;
const
NMAX :Integer = 1048576;
label
_10,_20,_30,_40;
begin
IERR := 0;
if ( N  =  0 ) 
 then goto _40;
if ( N  <=  NMAX ) 
 then goto _10;
IERR := 65;
UTQS10(IERR,16);
goto _40;
_10:
D := B - A;
D1 := D/N;
IN_ := 1;
KK := 1;
P := 1.0;
for K:=1 to N do
 begin
  X := A + (K - 1)*D1;
  F(X,F1,F2);
  U[K-1] := F1;
  V[K-1] := F2;
_20:
 end;
FTF1C(U,V,N,IN_,KK,P);
for K:=1 to N do
 begin
  U[K-1] := D1*U[K-1];
  V[K-1] := D1*V[K-1];
_30:
 end;
_40:
end;

end.
